<div class="container">
  <br>
  <h1 class="text-center">Problem Set 4</h1>

  <h2>User Management System</h2>
  <p>
    Since we assume the system will be used by the organization internally, user registration is not included.
    Only Admin will add new user.Please use the following credentials to login as admin user.
  </p>
  <pre>
    E-mail: admin@teleconsult.com
    Password: password
  </pre>

  <%#= link_to 'User Management System', new_user_session_url, class: 'btn btn-danger d-flex justify-content-center' %>
  <%= link_to 'Tele-health Consult Myanmar', 'https://telehealthconsultmm.com/' %>

  <br/>

  <div class="question question-1 card">
    <div class="card-body">
      <h4 class="card-title">All social Web applications have users, content, and some kind of user-to-content map. Specify what
kind of information each of these areas will have in your application.</h4>
      <p>Admin</p>
      <ul>
        <li>View Users</li>
        <li>Add Users</li>
        <li>Ban Users</li>
        <li>Edit User Profile</li>
      </ul>
      <p>Reception</p>
      <ul>
        <li>Get medical officer list</li>
        <li>Get doctor list</li>
      </ul>
      <p>Team Leader</p>
      <ul>
        <li>Get reception list</li>
        <li>Get doctor list</li>
        <li>Get medical officer list</li>
        <li>Assign Team</li>
        <li>Remove members from the team</li>
      </ul>
      <p>Doctor</p>
      <ul>
        <li>Have profile on doctor's occupation, specialiation and work experience</li>
        <li>Get specialist list</li>
      </ul>
    </div>
  </div>

  <br>

  <div class="question question-2 card">
    <div class="card-body">
      <h4 class="card-title">Learn how to avoid SQL injection and XSS attacks in your development framework and document and
follow your plan for the rest of the project.</h4>
      <h5>XSS Attacks</h5>
      <p>Cross-site scripting (XSS) attack is a type of injection attack where the attacker tries insert malicious
        “client-side script” into websites for it to be processed by the victim’s web browser. Accessing cookies, session token,
        redirection users to unsafe sites, and presenting counterfeit sites are some of the motives behind XSS attacks. Generally,
        client-side script are considered to be benign due to the execution of the scripts being limited to a sandbox which restricts
        the execution environment. However, even within that restricted environment, the script can still access the current page and
        all the information with it. This can still allow the attacker access things like local storage and cookies through some malign
        code. XSS attacks are in fact considered to be one of the greatest threat against web applications.</p>
      <h6>Preventing XSS Attacks</h6>
      <p>Ruby on Rails has a build-in system for XSS prevention which escapes
         all HTML tags by default in the data being rendered from rails to output in web pages.
         However, it is still not enough as XSS attacks are still being discovered on rails applications.
         ‘HTML Escaping’ and ‘Sanitize’ are two of the most common measures taken in web applications against this type of attack.</p>
      <p>HTML Escaping -	A method in which Rails changes HTML opening and closing tags, and other special character to some other
        characters in order to prevent the script from running.</p>
      <p>A method in which all HTML tags and attributes are removed except for the allowed ones.</p>

      <h5>SQL Injection</h5>
      <p>SQL injection is an injection-based attack in web applications where the attacker enters data in the input field with the aim of manipulating
        SQL queries. Generally to launch an SQL injection, the attackers needs to know about the data schema and/or needs to have some input data not validated. </p>
      <h6>Some of theCounter-measures against SQL Injection for Rails</h6>
      <ul>
        <li>Sanitizing input data</li>
        <li>HTMl Escaping</li>
        <li>Removing inscure gems</li>
        <li>Pass input as a parameter instead of passing it directly</li>
        <li>User attribute-based equivalent</li>
      </ul>
    </div>
  </div>

  <br>

  <div class="question question-3 card">
    <div class="card-body">
      <h4 class="card-title">Audit your software for any sensitive data like database passwords make sure they are secure. Document
the result of your audit and plan.</h4>
      <p>We have used 'Device' gem for user authentication. Device uses 'Bcrypt' to store information securely. In the github web page
      of 'Devise', <%= link_to 'https://github.com/heartcombo/devise', 'https://github.com/heartcombo/devise'%>, It states that " Devise
      takes effort to generate random, secure tokens, and stores only token digests in the database, never plaintext". Using this gem,
      we can be sure that any sensitive data like database passwords are stored securely. However, in the future, we may plan further to
      secure our applicaton more.</p>
    </div>
  </div>

  <br>

  <div class="question question-4 card">
    <div class="card-body">
      <h4 class="card-title">Define your user data model</h4>
      <%= image_tag 'user_management_system_class.png', alt: 'Data Model' %>
    </div>
  </div>

  <br>

  <div class="question question-5 card">
    <div class="card-body">
      <h4 class="card-title">Sketch your user registration and management page flow</h4>
      <div class="row">
        <div class="col-6">
          <%= image_tag 'user_management_system_admin_sequence.png', alt: 'Data Model', style: 'height:auto;width:90%;'  %>
        </div>
        <div class="col">
          <%= image_tag 'user_management_system_doctor_sequence.png', alt: 'Data Model', style: 'height:auto;width:90%;'  %>
          <%= image_tag 'user_management_system_medicalOfficer_sequence.png', alt: 'Data Model', style: 'height:auto;width:90%;'  %>
          <%= image_tag 'user_management_system_reception_sequence.png', alt: 'Data Model', style: 'height:auto;width:90%;'  %>
          <%= image_tag 'user_management_system_teamleader_sequence.png', alt: 'Data Model', style: 'height:auto;width:90%;'  %>
        </div>
      </div>
    </div>
  </div>

  <br>

  <div class="question question-6 card">
    <div class="card-body">
      <h4 class="card-title">Using the techniques of test-first behavior-driven development we've studied in class and lab,
        build up the basic user registration and login pages. Make sure you have SSL enabled for the complete
        application to prevent password sniffng, make sure your session cookies are HttpOnly.</h4>
      <h4 class="text-center">Cucumber Test for Admin Functionailty and User Login</h4>
      <div class="d-flex align-items-end justify-content-center">
        <%= image_tag 'feature_admin.png', alt: 'Cucumber Test for Feature Admin', style: 'height:auto;width:40%;'%>
        <%= image_tag 'feature_user.png', alt: 'Cucumber Test for Feature User', style: 'height:auto;width:40%;' %>
      </div>
      <p>'Devise' gem was used to build up registration and login pages.</p>
    </div>
  </div>

  <br>

  <div class="question question-7 card">
    <div class="card-body">
      <h4 class="card-title">Again using BDD, build the user administration pages. Make sure admin can 1) see recently registered
        users, 2) ban a user, and 3) see statistics on user registrations.</h4>
      <%= image_tag 'admin_dashboard.png', alt: 'Cucumber Test for Feature User' %>
    </div>
  </div>

  <br>

  <div class="question question-8 card">
    <div class="card-body">
      <h4 class="card-title">Use your issue tracker and CI server to their full potential. Start an issue in the issue tracker before
you begin any work. Get email notication of broken builds running, and get the CI server to report
test coverage and code quality metrics.</h4>
      <h4 class="text-center">CI/CD Pipeline</h4>
      <%= image_tag 'CI_tracker.png', alt: 'CI/CD Pipeline' %>
      <h4 class="text-center">Issue Tracker</h4>
      <%= image_tag 'issue_tracker.png', alt: 'Issue Tracker' %>
    </div>
  </div>

  <br/>
  <br/>
</div>
